Group: Other
# BEGIN SourceDeps(oneline):
BuildRequires(pre): rpm-macros-fedora-compat rpm-macros-generic-compat
BuildRequires: /usr/bin/desktop-file-install gcc-c++
# END SourceDeps(oneline)
%define fedora 38
# see https://bugzilla.altlinux.org/show_bug.cgi?id=10382
%define _localstatedir %{_var}
%undefine   __brp_mangle_shebangs

Name:		magic
Version:	8.3.465
Release:	alt1_1
Summary:	A very capable VLSI layout tool

# SPDX confirmed
# LICENSE: NTP-0
# calma/:  NTP-0
# bplane/bpBins.c and etc: TCL
# drc/DRCcif.c: HPND
# scmos/COPYRIGHT: NPND
License:	NTP-0 AND TCL AND HPND
URL:		http://opencircuitdesign.com/%{name}/index.html

Source:	http://opencircuitdesign.com/%{name}/archive/%{name}-%{version}.tgz
Source1:	%{name}.desktop
Source2:	%{name}.png
Patch1:	%{name}-7.4.35-64bit.patch

BuildRequires:	gcc

BuildRequires:	libcairo-devel
BuildRequires:	libGL-devel
BuildRequires:	libGLU-devel
BuildRequires:	libGLw-devel
BuildRequires:	libXext-devel
BuildRequires:	libXi-devel
BuildRequires:	libXmu-devel
BuildRequires:	tk-devel
BuildRequires:	m4
BuildRequires:	desktop-file-utils
%if 0%{?fedora}
BuildRequires:	zlib-devel
%endif

BuildRequires:	blt
BuildRequires:	tcsh

Requires:	tcsh
Source44: import.info
# Special FEL Gnome/KDE menu structure

%description
Magic is a venerable VLSI layout tool. Magic VLSI remains
popular with universities and small companies.

Magic is widely cited as being the easiest tool to use for
circuit layout, even for people who ultimately rely on commercial
tools for their product design flow.

%package doc
Group: Other
Summary:	Documentation for magic, A very capable VLSI layout tool
Requires:	%{name} = %{version}-%{release}
BuildArch: noarch


%description doc
This package contains the documentation of magic in the postscript
and some tutorials.


%prep
# tarball includes unneeded symlink, so we firstly
# create a directory and expand tarball there.
%setup -q -T -c %{name}-%{version} -a 0
cd %{name}-%{version}

rm -rf readline
rm -rf risp

sed -i.cflags -e 's|CFLAGS=.*CFLAGS|:|' configure

sed -i.nocpp \
	scripts/configure.in scripts/configure \
	-e 's|-lstdc++||' \
	%{nil}

sed -i.arch scripts/defs.mak.in \
	-e 's|^INSTALL_LIBDIR.*$|INSTALL_LIBDIR\t=%{_libdir}|'

sed -i "s|/usr/local/bin/tclsh|%{_bindir}/tclsh|" tcltk/strip_reflibs.tcl
sed -i "s|package require -exact|package require|" tcltk/tkcon.tcl

%if "x%{?__isa_bits}" == "x64"
%patch1  -p0 -b .64bit
%endif

# Doesn't seem to need these.
sed -i scripts/configure \
	-e 's| -lfontconfig -lfreetype||'

%global __global_cflags_orig %{optflags}
%global __global_cflags %__global_cflags_orig -Werror=implicit-function-declaration -Werror=implicit-int

%build
cd %{name}-%{version}

export WISH_EXE=%{_bindir}/wish
%configure \
	--with-tcl=%{_libdir} \
	--with-tk=%{_libdir} \
	--with-tcllibs=%{_libdir} \
	--with-tklibs=%{_libdir} \
	%{nil}

#%make %%{?_smp_mflags}
# Parallel make _silently_ fails
make -j1 -k \
    UNUSED_MODULES=""

%install
cd %{name}-%{version}
make install \
	DESTDIR=%{buildroot} \
	INSTALL="install -c -p" \
	CP="cp -p"

desktop-file-install \
	--vendor "" \
	--dir %{buildroot}%{_datadir}/applications/ \
	%{SOURCE1}

# applying timestamps
cp -pr \
	README* \
	TODO \
	VERSION \
	scmos/ \
	..

cp -pr %{buildroot}%{_libdir}/%{name}/{doc/,tutorial} ..
rm -rf %{buildroot}%{_libdir}/%{name}/{doc/,tutorial}

rm -f doc/html/Makefile

chmod -x %{buildroot}%{_libdir}/%{name}/tcl/console.tcl

mkdir -p %{buildroot}%{_datadir}/icons/hicolor/128x128/apps/
install -cpm 0644 %{SOURCE2} \
	%{buildroot}%{_datadir}/icons/hicolor/128x128/apps/%{name}.png

# Remove manpage currently unused for TCL building
# to avoid file conflict (bug 1330507)
rm -f %{buildroot}%{_mandir}/man1/extcheck.1*

%files
%doc	README*
%doc	TODO
%doc	VERSION
%{_bindir}/%{name}
%{_bindir}/ext2sim
%{_bindir}/ext2spice

%dir	%{_libdir}/%{name}/
%dir	%{_libdir}/%{name}/tcl/
%{_libdir}/%{name}/sys/
%{_libdir}/%{name}/tcl/bitmaps/
%{_libdir}/%{name}/tcl/*tcl
%{_libdir}/%{name}/tcl/*.so
%{_libdir}/%{name}/tcl/magicdnull
%{_libdir}/%{name}/tcl/magicexec

%{_mandir}/man?/*
%{_datadir}/applications/%{name}.desktop
%{_datadir}/icons/hicolor/128x128/apps/%{name}.png

%files doc
%doc	doc/
%doc	tutorial/
%doc	scmos/

%changelog
* Sat Mar 23 2024 Igor Vlasenko <viy@altlinux.org> 8.3.465-alt1_1
- update to new release by fcimport

* Fri Dec 01 2023 Igor Vlasenko <viy@altlinux.org> 8.3.451-alt1_1
- update to new release by fcimport

* Sat Sep 16 2023 Igor Vlasenko <viy@altlinux.org> 8.3.429-alt1_1
- update to new release by fcimport

* Thu Aug 31 2023 Igor Vlasenko <viy@altlinux.org> 8.3.426-alt1_1
- update to new release by fcimport

* Wed Feb 22 2023 Igor Vlasenko <viy@altlinux.org> 8.3.366-alt1_1
- update to new release by fcimport

* Sun Aug 07 2022 Igor Vlasenko <viy@altlinux.org> 8.3.315-alt1_2
- update to new release by fcimport

* Tue Jul 05 2022 Igor Vlasenko <viy@altlinux.org> 8.3.315-alt1_1
- update to new release by fcimport

* Fri May 06 2022 Igor Vlasenko <viy@altlinux.org> 8.3.298-alt1_1
- update to new release by fcimport

* Thu May 05 2022 Igor Vlasenko <viy@altlinux.org> 8.3.291-alt1_1
- update to new release by fcimport

* Sat Feb 05 2022 Igor Vlasenko <viy@altlinux.org> 8.3.263-alt1_1
- update to new release by fcimport

* Thu Jan 20 2022 Igor Vlasenko <viy@altlinux.org> 8.3.257-alt1_1
- update to new release by fcimport

* Sun Jan 02 2022 Igor Vlasenko <viy@altlinux.org> 8.3.245-alt1_1
- update to new release by fcimport

* Thu Dec 16 2021 Igor Vlasenko <viy@altlinux.org> 8.3.239-alt1_1
- update to new release by fcimport

* Wed Dec 01 2021 Igor Vlasenko <viy@altlinux.org> 8.3.229-alt1_1
- update to new release by fcimport

* Tue Nov 02 2021 Igor Vlasenko <viy@altlinux.org> 8.3.221-alt1_1
- update to new release by fcimport

* Fri Oct 22 2021 Igor Vlasenko <viy@altlinux.org> 8.3.220-alt1_1
- update to new release by fcimport

* Wed Oct 13 2021 Igor Vlasenko <viy@altlinux.org> 8.3.212-alt1_1
- update to new release by fcimport

* Mon Sep 20 2021 Igor Vlasenko <viy@altlinux.org> 8.3.205-alt1_1
- update to new release by fcimport

* Mon Aug 02 2021 Igor Vlasenko <viy@altlinux.org> 8.3.191-alt1_1
- update to new release by fcimport

* Sun Jul 25 2021 Igor Vlasenko <viy@altlinux.org> 8.3.188-alt1_1
- update to new release by fcimport

* Thu Jul 08 2021 Igor Vlasenko <viy@altlinux.org> 8.3.182-alt1_1
- update to new release by fcimport

* Mon May 17 2021 Igor Vlasenko <viy@altlinux.org> 8.3.162-alt1_1
- update to new release by fcimport

* Wed Apr 14 2021 Igor Vlasenko <viy@altlinux.org> 8.3.149-alt1_1
- update to new release by fcimport

* Wed Mar 17 2021 Igor Vlasenko <viy@altlinux.org> 8.3.138-alt1_1
- update to new release by fcimport

* Wed Jan 27 2021 Igor Vlasenko <viy@altlinux.ru> 8.3.117-alt2_1
- update to new release by fcimport

* Tue Jan 26 2021 Igor Vlasenko <viy@altlinux.ru> 8.3.117-alt1_1
- update to new release by fcimport

* Wed Jan 13 2021 Igor Vlasenko <viy@altlinux.ru> 8.3.111-alt1_1
- update to new release by fcimport

* Fri Dec 25 2020 Igor Vlasenko <viy@altlinux.ru> 8.3.100-alt1_1
- update to new release by fcimport

* Sun Nov 01 2020 Igor Vlasenko <viy@altlinux.ru> 8.3.73-alt1_1
- update to new release by fcimport

* Thu Oct 08 2020 Igor Vlasenko <viy@altlinux.ru> 8.3.61-alt1_1
- update to new release by fcimport

* Thu Oct 01 2020 Igor Vlasenko <viy@altlinux.ru> 8.3.54-alt1_1
- update to new release by fcimport

* Wed Sep 02 2020 Igor Vlasenko <viy@altlinux.ru> 8.3.50-alt1_1
- update to new release by fcimport

* Mon Jul 06 2020 Igor Vlasenko <viy@altlinux.ru> 8.3.31-alt1_1
- update to new release by fcimport

* Sat Jun 13 2020 Igor Vlasenko <viy@altlinux.ru> 8.3.5-alt1_1
- update to new release by fcimport

* Tue Apr 07 2020 Igor Vlasenko <viy@altlinux.ru> 8.2.196-alt1_2
- update to new release by fcimport

* Wed Mar 25 2020 Igor Vlasenko <viy@altlinux.ru> 8.2.196-alt1_1
- update to new release by fcimport

* Tue Mar 10 2020 Igor Vlasenko <viy@altlinux.ru> 8.2.190-alt1_1
- update to new release by fcimport

* Thu Feb 27 2020 Igor Vlasenko <viy@altlinux.ru> 8.2.186-alt1_1
- update to new release by fcimport

* Thu Dec 26 2019 Igor Vlasenko <viy@altlinux.ru> 8.2.174-alt1_1
- update to new release by fcimport

* Wed Nov 20 2019 Igor Vlasenko <viy@altlinux.ru> 8.2.157-alt1_1
- update to new release by fcimport

* Tue Oct 29 2019 Igor Vlasenko <viy@altlinux.ru> 8.2.151-alt1_1
- update to new release by fcimport

* Mon Sep 30 2019 Igor Vlasenko <viy@altlinux.ru> 8.2.142-alt1_1
- new version

